import { FormGroup, FormControl, Validators } from '@angular/forms';
import { Component, Input, Inject } from '@angular/core';
import { MatDialogRef, MAT_DIALOG_DATA } from '@angular/material';

export type DialogMode =
  | { mode: 'rename'; oldName: string }
  | { mode: 'create' };

@Component({
  selector: 'cse-course-details-dialog',
  templateUrl: './modify-plan-dialog.component.html',
})
export class ModifyPlanDialogComponent {
  public form: FormGroup;

  constructor(
    private dialogRef: MatDialogRef<ModifyPlanDialogComponent>,
    @Inject(MAT_DIALOG_DATA) public data: DialogMode,
  ) {
    const initialName = this.data.mode === 'rename' ? this.data.oldName : '';
    this.form = new FormGroup({
      planName: new FormControl(initialName, Validators.required),
    });
  }

  onSubmit() {
    switch (this.data.mode) {
      case 'rename':
        this.dialogRef.close({ name: `${this.form.value.planName}` });
        break;
      case 'create':
        this.dialogRef.close({ name: `${this.form.value.planName}` });
        break;
      default:
        this.dialogRef.close();
    }
  }

  onCancel() {
    this.dialogRef.close();
  }
}
